<%--
/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<c:choose>
	<c:when test="<%= Validator.isNotNull(url) %>">

		<%
		StringBundler sb = new StringBundler();

		if (autoplay) {
			sb.append("&amp;autoplay=1");
		}

		if (showThickerBorder) {
			sb.append("&amp;border=1");
		}

		sb.append("&amp;cc_load_policy=" + closedCaptioning);

		if (Validator.isNotNull(borderColor)) {
			sb.append("&amp;color1=" + borderColorHex);
		}

		if (Validator.isNotNull(playerColor)) {
			sb.append("&amp;color2=" + playerColorHex);
		}

		if (!enableKeyboardControls) {
			sb.append("&amp;disablekb=1");
		}

		if (enableEnhancedGenieMenu) {
			sb.append("&amp;egm=1");
		}

		if (enableFullscreen) {
			sb.append("&amp;fs=1");
		}

		if (hd) {
			sb.append("&amp;hd=1");
		}

		sb.append("&amp;iv_load_policy=" + annotations);

		if (loop) {
			sb.append("&amp;loop=1");
		}

		if (enableRelatedVideos) {
			sb.append("&amp;rel=1");
		}

		if (!showInfo) {
			sb.append("&amp;showinfo=0");
		}

		if (!enableSearch) {
			sb.append("&amp;showsearch=0");
		}

		if (Validator.isNotNull(startTime)) {
			sb.append("&amp;start=" + startTime);
		}
		%>

		<liferay-ui:flash
			allowFullScreen="true"
			allowScriptAccess="true"
			height="<%= height %>"
			movie="<%= _SWF_URL + id + sb.toString() %>"
			width="<%= width %>"
			wmode="opaque"
		>
			<aui:a href="<%= _WATCH_URL + id %>" rel="external" title='<%= LanguageUtil.get(pageContext, "watch-this-video-at-youtube") %>'>
				<img alt="<liferay-ui:message key="youtube-video" />" height="<%= height %>" src="<%= imageURL %>" width="<%= width %>" />
			</aui:a>
		</liferay-ui:flash>
	</c:when>
	<c:otherwise>
		<liferay-util:include page="/html/portal/portlet_not_setup.jsp" />
	</c:otherwise>
</c:choose>